<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  User.profile
 *
 * @copyright   Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// Check to ensure this file is included in Joomla!
defined('JPATH_BASE') or die( 'Restricted access' );

class plgUserPap4 extends JPlugin {

  /**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
	public function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		//$this->loadLanguage();
	}

	public function onUserAfterSave($user, $isNew, $result, $error) {
    if (!$isNew) return true;

    $userId	= JArrayHelper::getValue($user, 'id', 0, 'int');

		if ($userId && $result) {
      $args = array();
      $pos = strpos($user['name']," ");
      if ($pos !== false) {
        $args['fname'] = substr($user['name'],0,$pos-1);
        $args['lname'] = substr($user['name'],$pos+1);
      }
      else {
        $args['fname'] = "Joomla";
        $args['lname'] = $user['name'];
      }

      $args['email'] = $user['email'];
      $args['refid'] = $user['username'];
      $args['password'] = $_POST['password'];
      
      require_once("PapApi.class.php");
      $pap4Url = $this->params->get('pap4_url', 1);
      $pap4Username = $this->params->get('pap4_username', 1);
      $pap4Pwd = $this->params->get('pap4_password', 1);

      try {
        // login to API
        $session = new Gpf_Api_Session($pap4Url);
        if (!$session->login($pap4Username, $pap4Pwd)) {
          die("Please contact affiliate manager. Error message: ".$session->getMessage());
        }

        //identify the referrer (affiliate)
        $clickTracker = new Pap_Api_ClickTracker($session);
        try {
          $clickTracker->track();
          $clickTracker->saveCookies();

          $affiliate = $clickTracker->getAffiliate();
          $referralid = '';

          //if cookies were found - an affiliate was recongized as a referrer
          if ($affiliate !== null) {
            $referralid = @$affiliate->getParam('refid');
          }
        }
        catch (Exception $e) {
          //die("No parent affiliate recognized: ".$e->getMessage());
        }

        // create new affiliate
        $affiliate = new Pap_Api_Affiliate($session);
        $affiliate->setUsername($args['email']);
        $affiliate->setPassword($args['password']);
        $affiliate->setFirstname($args['fname']);
        $affiliate->setLastname($args['lname']);
        $affiliate->setRefid($args['refid']);
        if ($referralid != '') {
          $affiliate->setParentUserId($referralid);
        }
        if(!$affiliate->add()) {
          die("Cannot add record, please contact affiliate manager. Error message: ".$affiliate->getMessage());
        }
        else {
          //echo("Affiliate successfully added");
        }
      }
      catch(Exception $e) {
        die("PAP4 API call error, please contact affiliate manager. Error message: ".$e->getMessage());
      }
		}

		return true;
	}
}
?>